(vl-load-com)		;;; provede se hned pi nahrn funkce

(defun  rk:zmenKruh(volajObj reactorObj paramList / objVyplne pomocna polomer stred_kr pocet
		 vzdalenost pol_kresl)
  (if (vlax-property-available-p volajObj "Radius")
   (progn
    (setq objVyplne (vlr-data reactorObj))
    (while (> (length objVyplne) 0)
      (setq pomocna (cdr objVyplne))
      (vla-delete (car objVyplne))
      (setq objVyplne pomocna)
    )
    (setq objVyplne nil)
    (setq polomer (vla-get-radius volajObj))
    (setq stred_kr (vla-get-center volajObj))
    (setq pocet 1)   ;;; zskn potu kreslench krunic z asoc. seznamu gl_pam_hodnoty
    (setq vzdalenost (atof (cdr (assoc "vzdalenostke" gl_pam_hodnoty))))
    (while (> polomer (* vzdalenost pocet))	;;; dokud je co kreslit opakuj
      (setq pol_kresl (* vzdalenost pocet))	;;; nastav aktuln polomr
      (setq objVyplne
       (cons 
        (vla-addCircle modelProstor stred_kr pol_kresl)
         objVyplne
        )
       )
      (setq pocet (+ pocet 1))					;;; zmeni poet krunic o 1
    )
    (vlr-data-set reactorObj objVyplne)
   )
  )
)

(defun rk:vypisInformaci (volajiciReaktor informace / jmenoSouboru velikost)
    (vl-load-com)
    (setq jmenoSouboru (cadr informace)
        velikost (vl-file-size jmenoSouboru)
  )
  (alert (strcat "Velikost uloenho souboru " jmenoSouboru " je "
                 (itoa velikost) " byt;."
          )
  )
  (princ)
)

(defun c:reaktorKruh ()
;;; definice nov funkce kresli
;  (vlr-remove-all :vlr-object-reactor :vlr-dwg-reactor)
  (setq	gl_pam_hodnoty		;;; globln promnn uchovvajc jednotliv nastaven
     (list
	(cons "stredkex"     "0.0")	;;; x-ova souadnice stedu soust. krunic
	(cons "stredkey"     "0.0")	;;; y-ova souadnice stedu soust. krunic
	(cons "stredkez"     "0.0")	;;; z-ova souadnice stedu soust. krunic
	(cons "polomerke"    "1")		;;; polomr krunice (editbox)
	(cons "polomerks"    "1")		;;; polomr krunice (slider)
	(cons "vzdalenostke" "1")		;;; vzdlenost mezi krunicemi (editbox)
	(cons "vzdalenostks" "1")		;;; vzdlenost mezi krunicemi (slider)
	(cons "kruz_stred_but"  "0")	;;; tlatko - stred kruznice
     )
  )

  (if	(= (rk:dialog) T)
    (so:kresli_kruznici)			;;; vykreslen poadovanho objektu,
      									;;; v ppad e byly zadny hodnoty  
  )
  (vlr-dwg-reactor nil '((:vlr-saveComplete . rk:vypisInformaci)))
  (princ "Funkce reaktor kruh dokonila innost")	;;; informace o ukonen funkce
  (princ)
)

 
(defun rk:dialog (/ id co_delat vysledek)
  (setq id (load_dialog "D:/dialogKruh.dcl"))	;;; pedn jmna dialogovho boxu
    ;;; CESTU K UMSTN DIALOGU SE MUS AKTUALIZOVAT PODLE AKTUALNHO UMSTN

  (setq co_delat 2)
  (while (>= co_delat 2)			               ;;; opakuj pokud nenastane zmena
    (if	(not (new_dialog "dialogKruh" id))		;;; nen-li jmno dialogu vyber tak skoni
      (exit)
    )
    ;;; nastaven hodnot dialogovch prvk
    (set_tile "polomerke"    (cdr (assoc "polomerke"    gl_pam_hodnoty)))
    (set_tile "polomerks"    (cdr (assoc "polomerks"    gl_pam_hodnoty)))
    (set_tile "vzdalenostke" (cdr (assoc "vzdalenostke" gl_pam_hodnoty)))
    (set_tile "vzdalenostks" (cdr (assoc "vzdalenostks" gl_pam_hodnoty)))
    (set_tile "stredkex"     (cdr (assoc "stredkex"     gl_pam_hodnoty)))
    (set_tile "stredkey"     (cdr (assoc "stredkey"     gl_pam_hodnoty)))
    (set_tile "stredkez"     (cdr (assoc "stredkez"     gl_pam_hodnoty)))

    (action_tile "polomerks" "(so:vazba_prvku $value $reason \"polomerke\"  \"polomerks\")")
    (action_tile "vzdalenostks"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
		;;; je-li zmnn nkter posuvnk "slider.." zavolej funkci so:vazba_prvk
    (action_tile "stredkex"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkex\" $value)
          (assoc \"stredkex\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkey"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkey\" $value)
          (assoc \"stredkey\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkez"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkez\" $value)
          (assoc \"stredkez\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu krunice nastav odpovdajc hodnoty
    (action_tile "polomerke" "(so:vazba_prvku $value $reason \"polomerke\" \"polomerks\")")
    (action_tile "vzdalenostke"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
		;;; je-li zmnn nkter editbox zavolej funkci so:vazba_prvku

    (action_tile "kruz_stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "kruz_stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "accept" "(done_dialog 1)")
		;;; je-li zmknuto tlatko "accept"
    		;;; zavolej funkci done_dialog s hodnotou 1
    (action_tile "cancel" "(done_dialog 0)")
		;;; je-li zmknuto tlatko "cancel"
    		;;; zavolej funkci done_dialog s hodnotou 0
  
    (setq co_delat (start_dialog))
		;;; nastav promnnou na hodnotu zskanou od funkce start_dialog
		;;; (hodnota s kterou kon funkce done_dialog)
    (cond	;;; uren dal innosti
      ((= co_delat 0) (setq vysledek nil))	;;; uivatel stornoval dialog = konec funce
      ((= co_delat 1) (setq vysledek T))	;;; uivatel potvrdil dialog,
      						;;; zavolej funkci (vykresli)
      ((= co_delat 4) (so:nastav_stred (getpoint "\nVbr bodu:")))
				;;; uivatel zmkl tlatko pro zadn souadnic stedu
	    			;; zavolej funkci nastav_sted
    )
  )
  (unload_dialog id)		;;; odstran dialog id z pamti
    vysledek			;;; vrcen vsledku funkce (jestli probhla OK)
)

(defun so:nastav_stred (stred / stredx stredy stredz)
  (setq stredx (strcat (vl-princ-to-string (car stred))))
  (setq stredy (strcat (vl-princ-to-string (cadr stred))))
  (setq stredz (strcat (vl-princ-to-string (caddr stred))))

  (setq gl_pam_hodnoty
    (subst
	(cons  "stredkex" stredx)
        (assoc "stredkex" gl_pam_hodnoty)
	gl_pam_hodnoty
    )
  )
  (setq gl_pam_hodnoty
    (subst
	(cons  "stredkey" stredy)
        (assoc "stredkey" gl_pam_hodnoty)
	gl_pam_hodnoty
    )
  )
  (setq gl_pam_hodnoty
    (subst
        (cons  "stredkez" stredz)
        (assoc "stredkez" gl_pam_hodnoty)
        gl_pam_hodnoty
    )
  )
)

(defun so:kresli_kruznici (/ stred_kr polomer pol_kresl pocet vzdalenost objektyVyplne)
  (setq acadObjekt (vlax-get-acad-object)) 
  (setq acadDokument (vla-get-ActiveDocument acadObjekt))
  (setq modelProstor (vla-get-ModelSpace acadDokument)) 

  (setq stred_kr
    (list
      (atof (cdr (assoc "stredkex" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredkey" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredkez" gl_pam_hodnoty)))
    )
  )		;;; pevod t etzc reprezentujcch souadnice
  		;;; do promnn stred (poloky stred jsou typu float)
  (setq polomer (atof (cdr (assoc "polomerke" gl_pam_hodnoty))))
		;;; zskn polomru prvn krunice z asoc. seznamu gl_pam_hodnoty  
  (setq vzdalenost (atof (cdr (assoc "vzdalenostke" gl_pam_hodnoty))))
		;;; zskn vzdlenosti mezi krunicemi z asoc. seznamu gl_pam_hodnoty
  (setq pocet 1)
		;;; zskn potu kreslench krunic z asoc. seznamu gl_pam_hodnoty

  (command)	;;; ukonen vech pedchozch pkaz
  (setq objektyVyplne nil)
  (while (> polomer (* vzdalenost pocet))	;;; dokud je co kreslit opakuj
    (setq pol_kresl (* vzdalenost pocet))	;;; nastav aktuln polomr
    (setq objektyVyplne
      (cons 
        (vla-addCircle modelProstor (vlax-3d-point stred_kr) pol_kresl)
         objektyVyplne
      )
    )
    (setq pocet (+ pocet 1))					;;; zmeni poet krunic o 1
  )

  (setq hranicniKruh
   (vla-addCircle modelProstor
    (vlax-3d-point stred_kr) polomer
   )
  )

  
  (setq kruhReaktor   (vlr-object-reactor (list hranicniKruh)
	   objektyVyplne '((:vlr-modified . rk:zmenKruh))))
  (command "_zoom" "M")  
)

(defun so:vazba_prvku (val why editbox slider)
  (if (or (= why 2) (= why 1))
;;; zjisten jak akce uivatele zpsobila akci dialogu
;;; 2 = opustn editboxu
;;; 1 = uivatel vybral prvek (pklad entrem)
    (progn
      (setq edit_hodnota (atof val))
;;; peveden etzce reprezentujcho nastavenou hodnotu   na slo
      (if (> edit_hodnota 5000)
	(setq val "5000")	;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (if (< edit_hodnota 0)
	(setq val "0")		;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (set_tile editbox val)	;;; nastaven editboxu na sprvnou hodnotu
      (set_tile slider val)	;;; nastaven slideru na sprvnou hodnotu
      (setq gl_pam_hodnoty
	(subst
	  (cons editbox val)
	  (assoc editbox gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
	(subst
	  (cons slider val)
	  (assoc slider gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
    )
  )
)

;;; nakonec zobrazme informaci pro uivatele, jak m spustit funkci
(princ "\nNezapomete nastavit sprvnou cestu k dialogu ve funkci rk:dialog!!!")
(princ "\nFunkce se spout pkazem  (c:reaktorKruh) v IDE Visual LISPu")
(princ "\nFunkce se spout pkazem  reaktorKruh v AutoCADu")